/*
Copyright © Brian Buller <brian@bullercodeworks.com>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
package app

import (
	"fmt"
	"time"

	"git.bullercodeworks.com/brian/expds/data"
	w "git.bullercodeworks.com/brian/tcell-widgets"
	h "git.bullercodeworks.com/brian/tcell-widgets/helpers"
	"github.com/gdamore/tcell"
	"github.com/spf13/cobra"
)

type App struct {
	Name string
	h, w int

	running bool
	tScreen tcell.Screen

	screen AppScreen
	repo   *data.Repo

	AppLogs []data.AppLog

	style tcell.Style
}

func NewApp() *App {
	a := &App{
		style: tcell.StyleDefault.Foreground(tcell.ColorYellow),
	}
	err := a.init()
	cobra.CheckErr(err)
	return a
}

func (a *App) init() error {
	var err error
	a.repo, err = data.NewRepo()
	if err != nil {
		return fmt.Errorf("error initializing repo: %w", err)
	}
	if a.tScreen, err = tcell.NewScreen(); err != nil {
		return fmt.Errorf("error creating screen: %w", err)
	}
	if err = a.tScreen.Init(); err != nil {
		return fmt.Errorf("error initializing screen: %w", err)
	}
	a.tScreen.SetStyle(a.style)
	a.tScreen.Clear()

	a.SetScreen(&ScreenHome{})

	go func() {
		var err error
		for err == nil {
			time.Sleep(time.Millisecond * 100)
			err = a.PostNowEvent()
		}
	}()
	return err
}

func (a *App) Run(args []string) error {
	a.running = true
	for {
		if !a.running {
			return nil
		}
		if a.screen != nil {
			a.ClearScreen()
			a.screen.Draw()
		} else {
			a.DrawText(1, 1, "No screen loaded", tcell.StyleDefault)
		}

		a.tScreen.Show()
		// Poll Events
		ev := a.tScreen.PollEvent()
		switch ev := ev.(type) {
		case *tcell.EventResize:
			a.tScreen.Sync()
			a.w, a.h = ev.Size()
			a.screen.HandleResize(ev)
		case *tcell.EventKey:
			if ev.Key() == tcell.KeyCtrlC {
				a.Stop()
			} else if ev.Key() == tcell.KeyCtrlJ {
				// Ctrl+J is the keypad 'Enter'
				ev = tcell.NewEventKey(tcell.KeyEnter, 0, 0)
			}
			if a.screen != nil && !a.screen.HandleKey(ev) {
				// Screen didn't handle the key
			}
		case *tcell.EventTime:
			if a.screen != nil {
				a.screen.HandleTime(ev)
			}
		}
	}
	return nil
}

func (a *App) GetSize() (int, int) { return a.tScreen.Size() }
func (a *App) GetW() int           { return a.w }
func (a *App) GetH() int           { return a.h }

func (a *App) SetScreen(scr AppScreen) {
	a.screen = scr
	a.screen.Init(a)
	a.screen.HandleResize(tcell.NewEventResize(a.GetSize()))
}

func (a *App) GetTScreen() tcell.Screen { return a.tScreen }

func (a *App) Stop() { a.running = false }
func (a *App) PostNowEvent() error {
	ev := new(tcell.EventTime)
	ev.SetEventNow()
	return a.PostEvent(ev)
}

func (a *App) PostEvent(ev tcell.Event) error {
	if a.tScreen != nil {
		return a.tScreen.PostEvent(ev)
	}
	return nil
}
func (a *App) Sync()        { a.tScreen.Sync() }
func (a *App) ClearScreen() { a.tScreen.Clear() }
func (a *App) Exit()        { a.running = false }
func (a *App) Cleanup()     { a.tScreen.Fini() }

func (a *App) GetRepo() *data.Repo { return a.repo }

// Draw a rune to the screen
func (a *App) DrawRune(x, y int, style tcell.Style, r rune) {
	a.tScreen.SetContent(x, y, r, nil, style)
}

// Draw text to the screen
func (a *App) DrawText(x, y int, text string, style tcell.Style) {
	h.DrawText(x, y, text, style, a.tScreen)
}

// Draw a widget to the screen
func (a *App) DrawWidget(w w.Widget) { w.Draw(a.tScreen) }
